""" Basic template for Tilengine examples in Python """

import tilengine as tln

# helper constants
WIDTH 		 = 400
HEIGHT 		 = 240

# variables
class Layer:
	tileset = None
	tilemap = None
	palette = None

# load layer assets and basic setup
def load_layer (index, base_name):
	layer = Layer()
	layer.tileset = tln.LoadTileset (base_name + ".tsx")
	layer.tilemap = tln.LoadTilemap (base_name + ".tmx", None)
	layer.palette = tln.GetTilesetPalette (layer.tileset)
	tln.SetLayer (index, layer.tileset, layer.tilemap)
	return layer

# raster effect function
def raster_effect (line):
	return
	
# program point
def start():
	
	# init
	tln.Init (WIDTH,HEIGHT, 3,0,0)
	tln.CreateWindow (None, tln.CWF_VSYNC)
	tln.SetBGColor(0,0,0)

	# setup layers
	layer = load_layer (0, "Foreground")

	# setup raster callback (optional)
	my_raster_callback = tln.RasterCallbackFunc(raster_effect)
	tln.SetRasterCallback (my_raster_callback)

	# main loop
	while tln.ProcessWindow ():
		tln.DrawFrame (0)

	tln.Deinit ()

start()