import tilengine as tln

# helper constants
WIDTH 		 = 400
HEIGHT 		 = 240

# variables
frame = 0
psize = 0
delta = 0.4
target = 0

class Layer:
	tileset = None
	tilemap = None
	palette = None

# load layer
def load_layer (index, base_name):
	layer = Layer()
	layer.tileset = tln.LoadTileset (base_name + ".tsx")
	layer.tilemap = tln.LoadTilemap (base_name + ".tmx", None)
	layer.palette = tln.GetTilesetPalette (layer.tileset)
	tln.SetLayer (index, layer.tileset, layer.tilemap)
	return layer

# linear interpolation
def lerp (x, x0, x1, fx0, fx1):
	return fx0 + (fx1 - fx0)*(x - x0)/(x1 - x0)
	
# raster effect function
def raster_effect (line):
	None

# init
tln.Init (WIDTH,HEIGHT, 3,0,0)
tln.CreateWindow (None, tln.CWF_VSYNC)
tln.SetBGColor (28,0,140)

# setup layers
layer_fg = load_layer (0, "Foreground")
layer_bg = load_layer (1, "Background")

# setup raster callback
my_raster_callback = tln.RasterCallbackFunc(raster_effect)
tln.SetRasterCallback (my_raster_callback)

# main loop
while tln.ProcessWindow ():
	frame += 1
	psize += delta
	if psize >= 16:
		delta = -delta
	if psize <= 0:
		delta = -delta
		target ^= 1

	size = int(psize)
	tln.SetLayerMosaic (target,size,size)
	tln.SetLayerPosition (0, frame/2,0)
	tln.SetLayerPosition (1, frame/5,0)	
	tln.DrawFrame (0)

tln.Deinit ()
