""" Tut4: Introduction to raster effects """

import tilengine as tln

# initialise
tln.Init (400,240,2,80,1)
tln.CreateWindow (None, tln.CWF_VSYNC)

# setup the foreground layer
fg_tileset = tln.LoadTileset ("Foreground.tsx")
fg_tilemap = tln.LoadTilemap ("Foreground.tmx", "Layer 1")
tln.SetLayer (0, fg_tileset, fg_tilemap)

# setup the background layer
bg_tileset = tln.LoadTileset ("Background.tsx")
bg_tilemap = tln.LoadTilemap ("Background.tmx", "Layer 1")
tln.SetLayer (1, bg_tileset, bg_tilemap)

# our raster effect function: alternate background between sky and water
def raster_effect (line):
	if line == 0:
		tln.SetBGColor (28,0,140)
	elif line == 144:
		tln.SetBGColor (0,128,238)

# setup raster callback
my_raster_callback = tln.RasterCallbackFunc(raster_effect)
tln.SetRasterCallback (my_raster_callback)

# game loop
while tln.ProcessWindow ():
	tln.DrawFrame (0)
	
# release resources
tln.Deinit ()
