""" Tut8.1: sprite vs sprite collision """

import tilengine as tln
import random
WIDTH = 400
HEIGHT = 240
SPRITES = 6

# initialise
tln.Init (WIDTH,HEIGHT,2,SPRITES,1)
tln.SetBGColor (0,0,0)
tln.CreateWindow (None, tln.CWF_VSYNC)

# load spriteset and alternative palette
hero = tln.LoadSpriteset ("Hero")
palette_src = tln.GetSpritesetPalette (hero)
palette_alt = tln.LoadPalette ("Hero_alt.act")

#initialize some sprites with random position and scaling
for n in range(0,SPRITES):
	tln.SetSpriteSet (n, hero)
	tln.SetSpritePicture (n, 11)
	tln.SetSpritePosition (n, random.randint(0,WIDTH),random.randint(0,HEIGHT))
	tln.SetSpriteScaling (n, 1.0 + random.random(),  1.0 + random.random())
	tln.EnableSpriteCollision (n, True)

# game loop
x = 0
y = 0
tln.SetSpritePicture (0, 0)
tln.ResetSpriteScaling (0)
while tln.ProcessWindow ():
	# process user input
	if tln.GetInput(tln.INPUT_LEFT) and x > 0:
		x -= 1
	elif tln.GetInput(tln.INPUT_RIGHT) and x < WIDTH:
		x += 1
	if tln.GetInput(tln.INPUT_UP) and y > 0:
		y -= 1
	elif tln.GetInput(tln.INPUT_DOWN) and y < HEIGHT:
		y += 1
	tln.SetSpritePosition (0, x,y)
	
	# set sprite palette depending on collision status
	for n in range (0, SPRITES):
		if tln.GetSpriteCollision (n):
			tln.SetSpritePalette (n, palette_alt)
		else:
			tln.SetSpritePalette (n, palette_src)
	tln.DrawFrame (0)
	
tln.Deinit ()
