""" Tut8.2: sprite vs layer collision """

import tilengine as tln

# initialise
tln.Init (400,240,2,8,1)
tln.SetBGColor (0,0,0)
tln.CreateWindow (None, tln.CWF_VSYNC)

# load spriteset and alternative palette
hero = tln.LoadSpriteset ("Hero")
palette_src = tln.GetSpritesetPalette (hero)
palette_alt = tln.LoadPalette ("Hero_alt.act")
tln.SetSpriteSet (0, hero)

# setup foreground layer
fg_tileset = tln.LoadTileset ("Foreground.tsx")
fg_tilemap = tln.LoadTilemap ("Foreground.tmx", "Layer 1")
tln.SetLayer (0, fg_tileset, fg_tilemap)

# game loop
x = 0
y = 0
info = tln.TileInfo()
info_ptr = tln.CreateTileInfoPtr(info)

tiles = [0]*6

while tln.ProcessWindow ():
	# process user input
	if tln.GetInput(tln.INPUT_LEFT):
		x -= 1
	elif tln.GetInput(tln.INPUT_RIGHT):
		x += 1
	if tln.GetInput(tln.INPUT_UP):
		y -= 1
	elif tln.GetInput(tln.INPUT_DOWN):
		y += 1
	tln.SetSpritePosition (0, x,y)
	
	tln.GetLayerTile (0, x,y, info_ptr)
	if info.index == 0:
		tln.SetSpritePalette (0, palette_src)
	else:
		tln.SetSpritePalette (0, palette_alt)
	
	tln.DrawFrame (0)
	
tln.Deinit ()

def GetTileNumber (layer_index, x,y):
	tln.GetLayerTile (0, x,y, info_ptr)
	return info.index
	