""" Tut2: Working with layers """

import tilengine as tln
import math

WIDTH = 400
HEIGHT = 240

# initialise
tln.Init (WIDTH,HEIGHT,2,0,0)
tln.SetBGColor (0,136,238)
tln.CreateWindow (None, tln.CWF_VSYNC)
frame = 0

# load layer data
tileset = tln.LoadTileset ("Foreground.tsx")
tilemap = tln.LoadTilemap ("Foreground.tmx", "Layer 1")

# setup layer "player 1"
layer1_x = 0
layer1_y = -16
tln.SetLayer (0, tileset, tilemap)

# setup layer "player 2"
layer2_x = 800
layer2_y = 16
tln.SetLayer (1, tileset, tilemap)

# game loop
while tln.ProcessWindow ():
	midpoint = WIDTH/2 + int(math.sin(math.radians(frame*2))*32)
	tln.SetLayerClip (0, 0,0, midpoint - 1,HEIGHT)
	tln.SetLayerClip (1, midpoint,0, WIDTH,HEIGHT)	
	tln.SetLayerPosition (0, layer1_x, layer1_y)
	tln.SetLayerPosition (1, layer2_x, layer2_y)
	tln.DrawFrame (0)
	layer1_x += 2
	layer2_x -= 2
	frame += 1
	
# release resources
tln.Deinit ()
